/*File: filesync_functions.h*/

#ifndef FILESYNC_FUNCTIONS_H
#define	FILESYNC_FUNCTIONS_H


#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <pthread.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include "queue.h"
#include "message.h"
#include "MD5.h"
#include "Hash_tree.h"


/*elengxei an to directory yparxei, an einai directory*/
int directory_exists(char *directory);
/*diavazei to directory kai pernaei stin oura minimata calculate hash gia ta threads*/
void create_messages();
/*stelnei sto server minima getfiles kai oles tis aparaitites plirofories*/
void server_getfiles();
/*lamvanei apo ton server ta minimata expect kai fileinfo kai ta pernaei sti oura*/
void server_response();
/*sygrinei kai synxronizei ta arxeia ston topiko katalogo me auton ston server*/
void synchronize();
/*anadromiki klisi gia tin sygrisi dyo arxeio kai enimerosi ton diaforon*/
void comparison(qnode_ptr node1, qnode_ptr node2, int position, char *filename, int filesize);
/*synartisi ton worker threads*/
void *worker_thread(void *argp);


extern int sock, queue_size, array_size, tree_height, tree_fanout, running;
/*onoma directory pou theloume na sygchronisoume*/
extern char *directory;
/*oures gia ta apotelesmata apo server, apo ta threads kai oura gia calculate hash minimata*/
extern qhead_ptr server_queue, threads_queue, calc_queue;
/*pinakas me ta threads*/
extern pthread_t *threads;
/*mutex kai condition gia adeia oura*/
extern pthread_mutex_t queue_empty_mtx;
extern pthread_cond_t queue_empty_cond;


#endif	/* FILESYNC_FUNCTIONS_H */

