/* File: queue.c */


#include "queue.h"


int queue_init(qhead_ptr *qhead)
{
    if((*qhead = malloc(sizeof(qhead))) == NULL)
    {
        perror("malloc failed");
        return 1;
    }
    
    (*qhead)->first = NULL;
    (*qhead)->last = NULL;
    (*qhead)->size = 0;
    
    return 0;
}


void queue_insert(qhead_ptr qhead, qnode_ptr new_node)
{
    new_node->next = NULL;
    if(!queue_not_empty(qhead))
    {
        qhead->first = new_node;
        qhead->last = qhead->first;
        qhead->size++;                
    }
    else
    {
        qnode_ptr cur_node, prev_node;
        
        prev_node = NULL;
        cur_node = qhead->first;
        while(strcmp(new_node->msg.filename, cur_node->msg.filename) > 0)
        {
            prev_node = cur_node;
            cur_node = cur_node->next;

            if(cur_node == NULL)
            {
                prev_node->next = new_node;
                qhead->last = new_node;
                qhead->size++;     
                return;
            }
        }
        
        new_node->next = cur_node;

        prev_node == NULL ? (qhead->first = new_node) : (prev_node->next = new_node);

        qhead->size++;                                         
    }
}


qnode_ptr queue_extract(qhead_ptr qhead)
{
    qnode_ptr temp_node;
    temp_node = qhead->first;
    
    qhead->first = qhead->first->next;
    qhead->size--;
    
    return temp_node;
}

int queue_not_empty(qhead_ptr qhead)
{
    if(qhead->size == 0)
        return 0;
    else
        return 1;
}

void queue_print(qhead_ptr qhead)
{
    int i = 1;
    qnode_ptr temp_node = qhead->first;
    while(temp_node != NULL)
    {
        printf("Queue node %d with filename: %s\n", i, temp_node->msg.filename);
        fflush(stdout);
        temp_node = temp_node->next;
        i++;
    }
}


void queue_destroy(qhead_ptr qhead, int array_size)
{
    qnode_ptr temp_node = qhead->first;
    while(temp_node != NULL)
    {
        free(temp_node->msg.filename);
        
        int k;
        for (k = 0; k < array_size; k++)
        {
            free(temp_node->msg.hash_tree[k]);
        }
        free(temp_node->msg.hash_tree);     
        free(temp_node);

        temp_node = temp_node->next;
    }    
    
    free(qhead);
}
