/* File: filesynd_functions.h */

#ifndef FILESYND_FUNCTIONS_H
#define	FILESYND_FUNCTIONS_H


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <pthread.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include "Hash_tree.h"
#include "queue.h"
#include "message.h"


/*synartisi pou dimiourgei, parametropoiei, kanei bind kai listen ena socket*/
int sock_create(int *sock, int port_num, int listen_num);
/*synartisi gia tis aparaitites energeies kata tin lipsi getfiles minimatos*/
int getfiles(qnode_ptr queue_msg, int socket);
/*synartisi gia tis aparaitites energeies kata tin lipsi expect minimatos*/
int expect(qnode_ptr queue_msg, int socket);
/*synartisi gia tis aparaitites energeies kata tin lipsi fileinfo minimatos*/
int fileinfo(qnode_ptr queue_msg, int socket);
/*synartisi gia tis aparaitites energeies kata tin lipsi getdata minimatos*/
int getdata(qnode_ptr queue_msg, int socket);
/*synartisi gia tis aparaitites energeies kata tin lipsi data minimatos*/
int data(qnode_ptr queue_msg, int socket);
/*synartisi gia tis aparaitites energeies kata tin lipsi error minimatos*/
int error(qnode_ptr queue_msg, int socket);
/*synartisi ton worker threads*/
void *worker_thread(void *argp);
/*synartisi gia tin diaxeirisi ton simaton*/
void interrupt_handler(int signo);

extern int ext_port, inter_port, queue_size, pool_size, tree_height, tree_fanout, running;
/*pinakas me ta threads*/
extern pthread_t *threads;
/*oura epikoinonias main thread-worker threads*/
extern qhead_ptr threads_queue;
/*mutex kai condition gia adeia oura*/
extern pthread_mutex_t queue_empty_mtx;
extern pthread_cond_t queue_empty_cond;
/*mutex kai condition gia gemati oura*/
extern pthread_mutex_t queue_full_mtx;
extern pthread_cond_t queue_full_cond;
/*to sigaction gia ton handler simaton*/
static struct sigaction act; 

#endif	/* FILESYND_FUNCTIONS_H */

