/* File: queue.c */


#include "queue.h"


int queue_init(qhead_ptr *qhead)
{
    if((*qhead = malloc(sizeof(qhead))) == NULL)
    {
        perror("malloc failed");
        return 1;
    }
    
    (*qhead)->first = NULL;
    (*qhead)->last = NULL;
    (*qhead)->size = 0;
    
    return 0;
}


void queue_insert(qhead_ptr qhead, qnode_ptr new_node)
{
    new_node->next = NULL;
    if(!queue_not_empty(qhead))
    {
        qhead->first = new_node;
        qhead->last = qhead->first;
        qhead->size++;                
    }
    else
    {
        qhead->last->next = new_node;
        qhead->last = new_node;
        qhead->size++;        
    }
}


qnode_ptr queue_extract(qhead_ptr qhead)
{
    qnode_ptr temp_node;
    temp_node = qhead->first;
    
    qhead->first = qhead->first->next;
    qhead->size--;
    
    return temp_node;
}

int queue_not_empty(qhead_ptr qhead)
{
    if(qhead->size == 0)
        return 0;
    else
        return 1;
}

void queue_print(qhead_ptr qhead)
{
    int i = 1;
    qnode_ptr temp_node = qhead->first;
    while(temp_node != NULL)
    {
        printf("Queue node %d with message: %d\n", i, (int) temp_node->msg.id);
        fflush(stdout);
        temp_node = temp_node->next;
        i++;
    }
}